#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#define MAIN_FILE
#define Debug
#include "pclass.h"
#define FILE_NAME_LEN 	256
#define LINE_LEN	2048
#define itag		1
int VRCompare(VR *,VR *);
struct timeval tp;
void ParClassify();
  
int main(int argc, char *argv[])
{
  FILE *fp_data;
  char datafile[FILE_NAME_LEN], file_name[FILE_NAME_LEN];
  int i,j,k, mm,nn;
//  int elemspp;
//  int *inp_array;
  int (*fcnt)(const void*, const void*);
  double ts, te, io_t_1, io_t_2;
  if(argc < 5) {
      printf(" Usage: %s <datafile> <#recoreds> <#attributes> <#classes>\n",
		 argv[0]);
      printf("   <datafile>, is used to read data file\n");
      printf("   <#records>, number of records\n");
      printf("   <#attributes>, number of attributes\n");
      printf("   <#classes>, number of classes\n");
  }
  strcpy(datafile,argv[1]);
  nrec = atoi(argv[2]);
  natr = atoi(argv[3]);
  nclass = atoi(argv[4]);
  seconds(ts);
  seconds(io_t_1);
  catr = (Continuous *)calloc(natr,sizeof(Continuous));
  for(i=0;i<natr;i++) {
    if(!(catr[i].valsrids = (VR *)calloc(nrec, sizeof(VR)))) {
      printf("Memory Crunch @ catr[%d].valsrids\n",i);
    }
  }
  
  strcat(datafile, ".att");
  for(i=0;i<natr;i++) {
    sprintf(file_name, "%s.%d", datafile, i);
    fp_data = fopen(file_name, "r");
    for (j=0; j<nrec; j++) {
      fscanf(fp_data, "%d %d\n", &(catr[i].valsrids[j].val), &(catr[i].valsrids[j].cid));
      catr[i].valsrids[j].rid = j;
    }
    fclose(fp_data);
  }
  seconds(io_t_2);
  printf("done read data: %d",nrec);
  fcnt = (int (*)(const void *, const void *))VRCompare;
  for(i=0;i<natr;i++) {
    qsort(catr[i].valsrids,nrec,sizeof(VR),fcnt);
  }
  printf("Starting Classify\n");
  ParClassify();
 
  seconds(te);
  printf("Total execution time: %f\n", te-ts);
    printf("I/O time = %f\n", io_t_2 - io_t_1);
  printf("Computation time =%f\n", te-ts - (io_t_2 - io_t_1));
}

